
const fs = require("fs")
const os = require("os")
const path = require("path");

// 废弃，权限问题难以处理
// const KIT_HOME = "C:\\Program Files\\kit"
// const HOME = "C:\\Program Files\\kit\\.kit"
const KIT_HOME = path.resolve(os.homedir(), "AppData", "Local", "kit")
const HOME = path.resolve(os.homedir(), "AppData", "Local", "kit", ".kit")

function getModuleInfo(id){
    let homeDir = path.resolve(HOME, "modules", id)
    if ( "kit" === id ) {
        homeDir = KIT_HOME;
    }

    if ( ! fs.existsSync( homeDir ) ) {
        fs.mkdirSync( homeDir, { recursive : true } )
        return {
            HOME, KIT_HOME, exist : false, homeDir
        }
    }

    let versionFile = path.resolve(homeDir, "version")
    if ( ! fs.existsSync( versionFile ) ) {
        return {
            HOME, KIT_HOME, exist : true, homeDir
        }
    }

    return {
        HOME, KIT_HOME, exist : true, version : fs.readFileSync(versionFile, "UTF-8"), homeDir
    }

}

module.exports = { getModuleInfo  }